// hscrollDlg.cpp : implementation file
//

#include "stdafx.h"
#include "hscroll.h"
#include "HListBox.h"
#include "hscrollDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHscrollDlg dialog

CHscrollDlg::CHscrollDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHscrollDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHscrollDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CHscrollDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHscrollDlg)
	DDX_Control(pDX, IDC_LIST, c_List);
	DDX_Control(pDX, IDC_INSERT, c_Insert);
	DDX_Control(pDX, IDC_DELETE, c_Delete);
	DDX_Control(pDX, IDC_DATA, c_Data);
	DDX_Control(pDX, IDC_ADD, c_Add);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CHscrollDlg, CDialog)
	//{{AFX_MSG_MAP(CHscrollDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_BN_CLICKED(IDC_DELETE, OnDelete)
	ON_BN_CLICKED(IDC_INSERT, OnInsert)
	ON_EN_CHANGE(IDC_DATA, OnChangeData)
	ON_LBN_SELCHANGE(IDC_LIST, OnSelchangeList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHscrollDlg message handlers

BOOL CHscrollDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	updateControls();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CHscrollDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CHscrollDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CHscrollDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CHscrollDlg::OnOK() 
{
}

void CHscrollDlg::OnCancel() 
{
}

void CHscrollDlg::OnClose() 
{
	CDialog::OnOK();
}

void CHscrollDlg::updateControls()
    {
     c_Delete.EnableWindow(c_List.GetCurSel() >= 0);
     c_Insert.EnableWindow(c_List.GetCurSel() >= 0);
     c_Add.EnableWindow(c_Data.GetWindowTextLength() > 0);
    }

void CHscrollDlg::OnAdd() 
{
 CString s;
 c_Data.GetWindowText(s);
 c_List.AddString(s);
	
}

void CHscrollDlg::OnDelete() 
{
    int n = c_List.GetCurSel();
    if(n < 0)
	return;
    c_List.DeleteString(n);
    updateControls();
}

void CHscrollDlg::OnInsert() 
{
    int n = c_List.GetCurSel();
    if(n < 0)
	return;
    CString s;
    c_Data.GetWindowText(s);
    c_List.InsertString(n, s);
    updateControls();
}

void CHscrollDlg::OnChangeData() 
{
 updateControls();	
}

void CHscrollDlg::OnSelchangeList() 
{
 updateControls();	
}
